//+------------------------------------------------------------------+
//|                                                   _i_FXGauge.mq4 |
//|                                     Copyright  2006, Doji Starr |
//|                                                                  |
//|                                    adapted by jasondavis87(2011) |
//|                                         adapted by slimtom(2011) |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+


#property copyright "Copyright  2006, Doji Starr"

#property indicator_chart_window

#define NSL    8       // number of shade levels
#define NSVR   17      // number of solid vertical lines
#define NMA    7       // number of EMAs, change ma_period[NMA-1] and MA_color[NMA] accordingly 
#define NTF    4       // number of time frames/lanes, change tfp[NTF] accordinlgy

// input params
string info____ = "---- Chart Shift, Spacing, Width ----";
extern int Shift = 5;
extern int Spacing = 5;
extern int Width = 4;

extern string info_  = "---- Target Settings - SET to Zero to disable ---";
extern string info__ = "---- target_pips2 is thickest ---";
extern int target_pips1=0;    // 10;
extern int target_pips2=0;    // 15;
extern int target_pips3=0;    // 20;

// vars
double fml[NTF][NMA];                           // momentum lines
double bsl_up[NTF][NSL];                        // color shades levels to the up side
double bsl_down[NTF][NSL];                      // color shades levels to the down side
int srgap;                                     // color shades distances
double bsl[NSL];                               // color shades distances ('point' adjusted)
double srl[24];                                 // support/resistance levels (total = 2*NSL + NMA + 1(Bid) )
int _bsl[NSL] = {9, 16, 26, 42, 68, 110, 178, 244}; //time shades distance
int ma_period[6] = {21,34,55,75,100,144,233};   // EMAs, NMA-1
int tfp[NTF] = {1,5,15,60};                     // Time frames/lanes - in minutes. Like H4=240, D1=1440 etc...
color MA_color[NMA] = {LimeGreen,DarkViolet,MediumBlue,MediumBlue,MediumBlue,MediumBlue,SlateGray};
color Shade[NSL] = {C'255,250,150', C'255,220,120', C'255,190,90', C'255,160,60', C'255,130,30', C'255,100,0', C'255,0,0'};

//color Shade[NSL] = {LightBlue, LightSkyBlue, CornflowerBlue, RoyalBlue, Blue};
// color Shade[NSL] = {C'216,239,255', C'167,224,254', C'96,215,255', C'1,191,223', C'16,137,218', C'0,0,255', C'0,0,255'}; 
// color Shade[NSL] = {C'255,255,255', C'255,208,166', C'255,190,132', C'255,158,67', C'239,121,0', C'226,105,0', C'202,80,0'};
// color Shade[NSL] = {C'255,255,255', C'255,213,190', C'255,187,138', C'255,169,107', C'255,152,79', C'255,130,41', C'255,109,5'};

int counted_bars, startBar, bar, i;
int gap=10;
int tf, c, offset, xUnit;
int shift, spacing, width;
double point;
double tmpArray[NMA], lowestMA, highestMA;
double price;
string objName;
datetime curTime;
color col;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
deinit();

    xUnit = Period() * 60;
    shift = Shift * xUnit;
    spacing = Spacing * xUnit;
    width = Width * xUnit;
    
    for (i=0; i<NSL; i++)
        bsl[i] = _bsl[i]*point;

    // creating the objects for drawing the grid    
    for (tf=0; tf<NTF; tf++)
    {
        // shade rectangles and bars
        for (i=0; i<NSL; i++)
        {
            objName = "bsl_up_rect_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Shade[i]);
            
            objName = "ext_bsl_up_rect_"+tf;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            // Time frame/lane color
            ObjectSet(objName, OBJPROP_COLOR, Orange);
            
            objName = "bsl_down_rect_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Shade[i]);
            
            objName = "ext_bsl_down_rect_"+tf;
            ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
            // Time frame/lane color
            ObjectSet(objName, OBJPROP_COLOR, Orange);
            
            objName = "bsl_up_bar_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            // shade separator line color
            ObjectSet(objName, OBJPROP_COLOR, WhiteSmoke);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 1);
            
            objName = "bsl_down_bar_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            // shade separator line color
            ObjectSet(objName, OBJPROP_COLOR, WhiteSmoke);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 1);
        }

        objName = "MidShade_"+tf;
        ObjectCreate(objName, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
        ObjectSet(objName, OBJPROP_COLOR, White);
        
        // S&R boxes
        /* 
        objName = "Box1_"+tf;
        ObjectCreate(objName, OBJ_ARROW, 0, 0, 0);
        ObjectSet(objName, OBJPROP_ARROWCODE, 1);
        objName = "Box2_"+tf;
        ObjectCreate(objName, OBJ_ARROW, 0, 0, 0);
        ObjectSet(objName, OBJPROP_ARROWCODE, 1);
         */
        
        // momentum lines bars
        for (i=0; i<NMA; i++)
        {
            objName = "fml_bar_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_COLOR, Black);
            ObjectSet(objName, OBJPROP_RAY, false);
            if (i<2)
                ObjectSet(objName, OBJPROP_WIDTH, 5);
            else if (i==NMA-2 && tf>4){   // on the H4 & D1 last & pre-last (7th,8th) MA thicker
                ObjectSet(objName, OBJPROP_WIDTH, 5);
                ObjectSet(objName, OBJPROP_STYLE, STYLE_DOT);}
            else if (i==NMA-1)   // last(7th) MA thicker
                ObjectSet(objName, OBJPROP_WIDTH, 5);
            else
                ObjectSet(objName, OBJPROP_WIDTH, 1);
        }
        
        // solid vertical lines (of 10 pips or more)
        for (i=1; i<=NSVR; i++)
        {
            objName = "svr_"+tf+"_"+i;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 3);
            
            objName = "ext_up_svr_"+tf;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 3);
            
            objName = "ext_down_svr_"+tf;
            ObjectCreate(objName, OBJ_TREND, 0, 0, 0, 0, 0);
            ObjectSet(objName, OBJPROP_RAY, false);
            ObjectSet(objName, OBJPROP_WIDTH, 3);
        }

    }
        
    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
    // deleting the drawing objects
    for (tf=0; tf<NTF; tf++)
    {
        for (i=0; i<NSL; i++)
        {
            ObjectDelete("bsl_up_rect_"+tf+"_"+i);
            ObjectDelete("bsl_down_rect_"+tf+"_"+i);
            ObjectDelete("bsl_up_bar_"+tf+"_"+i);
            ObjectDelete("bsl_down_bar_"+tf+"_"+i);

        }
            ObjectDelete("ext_bsl_down_rect_"+tf);
            ObjectDelete("ext_bsl_up_rect_"+tf);
            ObjectDelete("ext_up_svr_"+tf);
            ObjectDelete("ext_down_svr_"+tf);
        ObjectDelete("MidShade_"+tf);
        
        ObjectDelete("Box1_"+tf);
        ObjectDelete("Box2_"+tf);
        
        for (i=0; i<NMA; i++)
            ObjectDelete("fml_bar_"+tf+"_"+i);
            
        for (i=1; i<=NSVR; i++)
            ObjectDelete("svr_"+tf+"_"+i);
    }

    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{


// Traffic lights
 double average1,average2;
   string dir="O";
   int tfc,mac;
  
   for(tfc=0; tfc<1; tfc++)   // always 1st time frame
   {
   for(mac=0; mac<NMA; mac++)
   {
   average1=iMA(Symbol(),tfp[tfc],ma_period[mac],0,MODE_SMA,PRICE_CLOSE,0);
   average2=iMA(Symbol(),tfp[tfc],ma_period[mac],0,MODE_SMA,PRICE_CLOSE,1);
  
   if (average1>average2) dir="^";
   if (average1<average2) dir="v";
   
   string obj_name;
   obj_name="Light "+DoubleToStr(tfc,0)+DoubleToStr(mac,0);
   show_light(obj_name,average1, MA_color[mac],mac,dir);
   
   }
   }
// Traffic lighs End   
   


// Grey TP/SL lines price distance 

init();

ObjectDelete("Highg");
ObjectDelete("Lowg");
if ( target_pips2 > 0 ) {
         ObjectCreate("Highg",OBJ_TREND,0,Time[100], Ask+(target_pips2*point),Time[1],Ask+(target_pips2*point));
      ObjectSet("Highg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Highg",OBJPROP_WIDTH,3);
      ObjectSet("Highg",OBJPROP_RAY,false);
      ObjectSet("Highg",OBJPROP_COLOR,Gray);
   
         ObjectCreate("Lowg",OBJ_TREND,0,Time[100], Bid-(target_pips2*point),Time[1],Bid-(target_pips2*point));
      ObjectSet("Lowg",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Lowg",OBJPROP_WIDTH,3);
      ObjectSet("Lowg",OBJPROP_RAY,false);
      ObjectSet("Lowg",OBJPROP_COLOR,Gray);
}
ObjectDelete("Highgl");
ObjectDelete("Lowgl");
if ( target_pips1 > 0 ) {
         ObjectCreate("Highgl",OBJ_TREND,0,Time[100], Ask+(target_pips1*point),Time[1],Ask+(target_pips1*point));
      ObjectSet("Highgl",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Highgl",OBJPROP_WIDTH,1);
      ObjectSet("Highgl",OBJPROP_RAY,false);
      ObjectSet("Highgl",OBJPROP_COLOR,Gray);
   
         ObjectCreate("Lowgl",OBJ_TREND,0,Time[100], Bid-(target_pips1*point),Time[1],Bid-(target_pips1*point));
      ObjectSet("Lowgl",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Lowgl",OBJPROP_WIDTH,1);
      ObjectSet("Lowgl",OBJPROP_RAY,false);
      ObjectSet("Lowgl",OBJPROP_COLOR,Gray);
}
ObjectDelete("Highgh");
ObjectDelete("Lowgh");
if ( target_pips3 > 0 ) {
         ObjectCreate("Highgh",OBJ_TREND,0,Time[100], Ask+(target_pips3*point),Time[1],Ask+(target_pips3*point));
      ObjectSet("Highgh",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Highgh",OBJPROP_WIDTH,1);
      ObjectSet("Highgh",OBJPROP_RAY,false);
      ObjectSet("Highgh",OBJPROP_COLOR,Gray);
   
         ObjectCreate("Lowgh",OBJ_TREND,0,Time[100], Bid-(target_pips3*point),Time[1],Bid-(target_pips3*point));
      ObjectSet("Lowgh",OBJPROP_STYLE,STYLE_SOLID);
      ObjectSet("Lowgh",OBJPROP_WIDTH,1);
      ObjectSet("Lowgh",OBJPROP_RAY,false);
      ObjectSet("Lowgh",OBJPROP_COLOR,Gray);
}
// End of Grey TP/SL lines 


// Start of Time lanes
point=Point;
if(point<0.0001) point=0.0001;

int short_gap_count;
int long_gap_count;
int sr_short_gap_count;
int sr_long_gap_count;

curTime = Time[0];
price = Close[0];    // price = Bid;

    
    for (tf=0; tf<NTF; tf++)
    {
//        bar = 0;
        bar = iBarShift(NULL, tfp[tf], curTime, false);

        // populating the fml array...
        for (i=0; i<NMA; i++)
            fml[tf][i] = iMA(NULL, tfp[tf], ma_period[i], 0, MODE_SMA, PRICE_CLOSE, bar/Period());

        // finding the highest and lowest MAs from the (7) fml's/MA's
        for (i=0; i<NMA; i++)
            tmpArray[i] = fml[tf][i];     // copying the MAs levels of this TF to one dim array to feed ArrayBsearch
        ArraySort(tmpArray);
        lowestMA = tmpArray[0];
        highestMA = tmpArray[6];

        // populating the bsl arrays...
        for (i=0; i<NSL; i++)
        {
            bsl_up[tf][i] = lowestMA + bsl[i];
            bsl_down[tf][i] = highestMA - bsl[i];
        }
    }
    
    // OK... now drawing
    for (tf=0; tf<NTF; tf++)
    {
        // drawing the color shades of the grid from top to bottom
        
        // find the number of overlapping shades
        offset = 0;
        for (i=offset; i<NSL-1; i++)
            if (bsl_up[tf][i] <= bsl_down[tf][i])
                offset++;

        // hide the objects of the first level of overlapping so they wont be left as 'ghosts'
        if (offset > 0)
        {
            objName = "bsl_up_rect_"+tf+"_"+(NSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);

            objName = "bsl_up_bar_"+tf+"_"+(NSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
        }
        
        double highest=0;
        for (i=NSL-2; i>=offset; i--)
        {
            objName = "bsl_up_rect_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_up[tf][i+1]);
                
            if (bsl_down[tf][i]>highest) highest=bsl_up[tf][i+1];
            
            objName = "bsl_up_bar_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width-xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_up[tf][i]);
        }
          
          
       objName = "ext_bsl_up_rect_"+tf;
       ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
       ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
       ObjectSet(objName, OBJPROP_PRICE1, highest);
       ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMax());
            
                objName = "ext_up_svr_"+tf;
                ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_PRICE1, highest);
                ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMax());   
                            ObjectSet(objName, OBJPROP_COLOR, Green); 
        objName = "MidShade_"+tf;
        ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
        ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
        ObjectSet(objName, OBJPROP_PRICE1, bsl_up[tf][offset]);
        ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][offset]);

        // hide the objects of the first level of overlapping so they wont be left as 'ghosts'
        if (offset > 0)
        {
            objName = "bsl_down_rect_"+tf+"_"+(NSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);

            objName = "bsl_down_bar_"+tf+"_"+(NSL-2-offset+1);
            ObjectSet(objName, OBJPROP_TIME1, 0);
            ObjectSet(objName, OBJPROP_TIME2, 0);
            ObjectSet(objName, OBJPROP_PRICE1, 0);
            ObjectSet(objName, OBJPROP_PRICE2, 0);
        }
           
      
        double lowest=9999.9999;
        for (i=0; i<NSL-1; i++)
        {
            objName = "bsl_down_rect_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][i+1]);
         
            if (bsl_down[tf][i]<lowest) lowest=bsl_down[tf][i+1];
            
            objName = "bsl_down_bar_"+tf+"_"+(i-offset);
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width-xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, bsl_down[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, bsl_down[tf][i]);
        }
        
            objName = "ext_bsl_down_rect_"+tf;
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width);
            ObjectSet(objName, OBJPROP_PRICE1, lowest);
            ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMin());
        
                objName = "ext_down_svr_"+tf;
                ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_PRICE1, lowest);
                ObjectSet(objName, OBJPROP_PRICE2, WindowPriceMin());
       
                    ObjectSet(objName, OBJPROP_COLOR, FireBrick);

        
/*        
        // drawing the boxes
        objName = "Box1_"+tf;
        ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
        ObjectSet(objName, OBJPROP_PRICE1, fml[tf][0]);
        if (fml[tf][0] > price+point/2)       col = Magenta;
        else if (fml[tf][0] < price-point/2)  col = Lime;
        else                                col = Brown;
        ObjectSet(objName, OBJPROP_COLOR, col);
        objName = "Box2_"+tf;
        ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
        ObjectSet(objName, OBJPROP_PRICE1, fml[tf][1]);
        if (fml[tf][1] > price+point/2)       col = Magenta;
        else if (fml[tf][1] < price-point/2)  col = Lime;
        else                                col = Brown;
        ObjectSet(objName, OBJPROP_COLOR, col);
*/        

        // drawing the momentum lines bars
        for (i=0; i<NMA; i++)
        {
            objName = "fml_bar_"+tf+"_"+i;
            ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+xUnit);
            ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+width-xUnit);
            ObjectSet(objName, OBJPROP_PRICE1, fml[tf][i]);
            ObjectSet(objName, OBJPROP_PRICE2, fml[tf][i]);
/*
            if (i<2)
            {
                if (fml[tf][i] > price+point/2)      col = Magenta;
                else if (fml[tf][i] < price-point/2) col = Lime;
                else                                col = Brown;
                ObjectSet(objName, OBJPROP_COLOR, col);
            }
*/            
            if (i==1)
            {
                if (fml[tf][i] >= price)        col = MA_color[1];     // OliveDrab;
                else if (fml[tf][i] < price)    col = MA_color[1];     // DarkViolet;
                ObjectSet(objName, OBJPROP_COLOR, col);
            }
            else if (i==0)
            {
                if (fml[tf][i] >= price)        col = MA_color[0];     // FireBrick;
                else if (fml[tf][i] < price)    col = MA_color[0];     // Green;
                ObjectSet(objName, OBJPROP_COLOR, col);
            }
            else if (i==NMA-2 && tf>4)
            {
                if (fml[tf][i] >= price)        col = MA_color[NMA-2];
                else if (fml[tf][i] < price)    col = MA_color[NMA-2];
                ObjectSet(objName, OBJPROP_COLOR, col);
            }
            
        }

        // drawing the solid vertical lines:
        // arranging all the bars levels in a single sorted array

     
        ArrayInitialize(srl, -1) ;
        for (i=0; i<NMA; i++)
            srl[i] = fml[tf][i];
        for (i=offset; i<NSL; i++)
        {
            srl[NMA+i] = bsl_down[tf][i]; // ? srl[7+i] = bsl_down[tf][i];
            srl[NMA+NSL+i] = bsl_up[tf][i]; // ? srl[7+NSL+i] = bsl_up[tf][i];
        }
        srl[NMA+2*NSL] = price; // ? srl[7+2*NSL] = price;
        ArraySort(srl);
        // looking for a gap of 10 pips or more
        c = 0;
        int supports=0;
        int resistances=0;
        for (i=0; i<NMA+2*NSL+2; i++) // ?for (i=0; i<7+2*NSL+2; i++)
        {
                        if(srl[i]>price) resistances++;
                if(srl[i]<price) supports++;
            if (-1 == srl[i])
                continue;
            if (srl[i+1]-srl[i] >= gap*point)
            {
                c++;
                objName = "svr_"+tf+"_"+c;
                ObjectSet(objName, OBJPROP_TIME1, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_TIME2, curTime+shift+tf*spacing+2*xUnit);
                ObjectSet(objName, OBJPROP_PRICE1, srl[i]+point);
                ObjectSet(objName, OBJPROP_PRICE2, srl[i+1]-point);

                if (srl[i+1] <= price)
                    {
                    if(price==srl[i+1])   short_gap_count++;
                    ObjectSet(objName, OBJPROP_COLOR, FireBrick);
                    }
                else
                    {
                    if(price==srl[i])  long_gap_count++;
                    ObjectSet(objName, OBJPROP_COLOR, Green);
                    }
            }
            if (srl[i+1]-srl[i] >= srgap*point)
            {
                if (srl[i+1] <= price)
                    if(price==srl[i+1])   sr_short_gap_count++;
                else
                    if(price==srl[i])  sr_long_gap_count++;
            }

        }
            if(supports==0) 
            {
             sr_short_gap_count++;
             short_gap_count++;
            }
            if(resistances==0) 
            {
             sr_long_gap_count++;
              long_gap_count++;
            }

        if (c >= NSVR)
            Print("Warning: NSVR exceeded");
        else
        {
            // hide the (only the first) unused vertical lines objects so they wont be left as 'ghosts'
//            for (sr=c; sr<NSVR; sr++)
            {
                objName = "svr_"+tf+"_"+(c+1);
                ObjectSet(objName, OBJPROP_TIME1, 0);
                ObjectSet(objName, OBJPROP_TIME2, 0);
                ObjectSet(objName, OBJPROP_PRICE1, 0);
                ObjectSet(objName, OBJPROP_PRICE2, 0);
            }
        }
    }
}



void show_light(string obj_name,double average,color lcolor,int mac,string dir)
  {
   mac=mac*3;
   // int xUnit = Period() * 60;
   ObjectDelete(obj_name);
   ObjectCreate(obj_name,OBJ_TEXT,0,Time[WindowFirstVisibleBar()]+2*xUnit+(mac*xUnit),WindowPriceMax()-0.001);  //,WindowPriceMax()-0.001,Time[0]+5*xUnit+(tfshift*xUnit),WindowPriceMax()-0.001);
   ObjectSetText(obj_name,dir,15);
   ObjectSet(obj_name,OBJPROP_COLOR, lcolor); 
    ObjectSet(obj_name,OBJPROP_RAY, false); 
     ObjectSet(obj_name,OBJPROP_WIDTH, 3); 
  
  }




